#include <SPI.h>
#include <MFRC522.h>

#define RST_PIN         9          // Configurable, see typical pin layout above
#define SS_1_PIN        10         // Configurable, take a unused pin, only HIGH/LOW required, must be diffrent to SS 2
#define SS_2_PIN        8          // Configurable, take a unused pin, only HIGH/LOW required, must be diffrent to SS 1
#define NR_OF_READERS   2

byte ssPins[] = {SS_1_PIN, SS_2_PIN};
MFRC522 mfrc522[NR_OF_READERS];

void setup() {

  Serial.begin(9600);
  while (!Serial);  
  SPI.begin();

  for (uint8_t reader = 0; reader < NR_OF_READERS; reader++) {
    mfrc522[reader].PCD_Init(ssPins[reader], RST_PIN); // Init each MFRC522 card
  }
  Serial.println(F("\t\t*** Поднесите карту к считывателю.***"));
  Serial.print ("вход:\t"); 
  Serial.print ("\t\t\t\t\tвыход: ");
  Serial.println(); 
}
 
void loop() {
  MFRC522::MIFARE_Key key;
  for (byte i = 0; i < 6; i++) key.keyByte[i] = 0xFF;
  byte block;
  byte len;
  MFRC522::StatusCode status;

  for (uint8_t reader = 0; reader < NR_OF_READERS; reader++) {  
    if (mfrc522[reader].PICC_IsNewCardPresent() && mfrc522[reader].PICC_ReadCardSerial()) {
         
 // **********************************************************************СЧИТЫВАТЕЛЬ-1  
   if(reader == 0) {    
 //------------------------------------------- Фамилия
  byte buffer1[18];
  block = 1;
  len = 18; 
  status = mfrc522[reader].PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, block, &key, &(mfrc522[reader].uid));
  if (status != MFRC522::STATUS_OK) {
    Serial.print(F("проверка ошибка "));
    Serial.println(mfrc522[reader].GetStatusCodeName(status));
    return;
  }
  status = mfrc522[reader].MIFARE_Read(block, buffer1, &len);
  //Фамилия
//  Serial.print(F("Фамилия:\t"));
  for (uint8_t i = 0; i < 16; i++){
    if (buffer1[i] != 32)
    {
      Serial.write(buffer1[i]);
    }
  }
  //------------------------------------------- Номер карты
  String content= "";
  for (byte i = 0; i < mfrc522[reader].uid.size; i++) 
  {
     content.concat(String(mfrc522[reader].uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522[reader].uid.uidByte[i], HEX));
  }
  Serial.print(F("\t"));
  content.toUpperCase();
  Serial.println(content);
      mfrc522[reader].PICC_HaltA();
      mfrc522[reader].PCD_StopCrypto1();
      }      
 // **********************************************************************СЧИТЫВАТЕЛЬ-2     
      if(reader == 1) { 
  //------------------------------------------- Фамилия
  Serial.print ("\t\t\t\t\t\t");
  byte buffer1[18];
  block = 1;
  len = 18; 
  status = mfrc522[reader].PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, block, &key, &(mfrc522[reader].uid));
  if (status != MFRC522::STATUS_OK) {
    Serial.print(F("проверка ошибка "));
    Serial.println(mfrc522[reader].GetStatusCodeName(status));
    return;
  }
  status = mfrc522[reader].MIFARE_Read(block, buffer1, &len);
  for (uint8_t i = 0; i < 16; i++){
    if (buffer1[i] != 32)
    {
      Serial.write(buffer1[i]);
    }
  }
  //------------------------------------------- Номер карты
  String content= "";
  for (byte i = 0; i < mfrc522[reader].uid.size; i++) 
  {
     content.concat(String(mfrc522[reader].uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522[reader].uid.uidByte[i], HEX));
  }
  Serial.print(F("\t"));
  content.toUpperCase();
  Serial.println(content);
      mfrc522[reader].PICC_HaltA();
      mfrc522[reader].PCD_StopCrypto1();
      }
    } 
  }
}
